# SPDX-License-Identifier: GPL-2.0
%YAML 1.2
---
$id: http://devicetree.org/schemas/iio/pressure/bmp085.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: BMP085/BMP180/BMP280/BME280/BMP380 pressure iio sensors

maintainers:
  - Andreas Klinger <ak@it-klinger.de>

description: |
  Pressure, temperature and humidity iio sensors with i2c and spi interfaces

  Specifications about the sensor can be found at:
    https://www.bosch-sensortec.com/bst/products/all_products/bmp180
    https://www.bosch-sensortec.com/bst/products/all_products/bmp280
    https://www.bosch-sensortec.com/bst/products/all_products/bme280
    https://www.bosch-sensortec.com/bst/products/all_products/bmp380
    https://www.bosch-sensortec.com/bst/products/all_products/bmp580

properties:
  compatible:
    enum:
      - bosch,bmp085
      - bosch,bmp180
      - bosch,bmp280
      - bosch,bme280
      - bosch,bmp380
      - bosch,bmp580

  reg:
    maxItems: 1

  vddd-supply:
    description:
      digital voltage regulator (see regulator/regulator.txt)

  vdda-supply:
    description:
      analog voltage regulator (see regulator/regulator.txt)

  reset-gpios:
    description:
      A GPIO line handling reset of the sensor. As the line is active low,
      it should be marked GPIO_ACTIVE_LOW (see gpio/gpio.txt)
    maxItems: 1

  interrupts:
    maxItems: 1

  drive-open-drain:
    description:
      set if the interrupt pin should be configured as open drain.
      If not set, defaults to push-pull configuration.
    type: boolean

  spi-max-frequency:
    maximum: 10000000

required:
  - compatible
  - vddd-supply
  - vdda-supply

allOf:
  - $ref: /schemas/spi/spi-peripheral-props.yaml#
  - if:
      properties:
        compatible:
          not:
            contains:
              enum:
                - bosch,bmp085
                - bosch,bmp380
                - bosch,bmp580
    then:
      properties:
        interrupts: false
  - if:
      properties:
        compatible:
          contains:
            enum:
              - bosch,bmp085
              - bosch,bmp180
    then:
      properties:
        spi-max-frequency: false

additionalProperties: false

examples:
  - |
    #include <dt-bindings/gpio/gpio.h>
    #include <dt-bindings/interrupt-controller/irq.h>
    i2c {
        #address-cells = <1>;
        #size-cells = <0>;
        pressure@77 {
            compatible = "bosch,bmp085";
            reg = <0x77>;
            interrupt-parent = <&gpio0>;
            interrupts = <25 IRQ_TYPE_EDGE_RISING>;
            reset-gpios = <&gpio0 26 GPIO_ACTIVE_LOW>;
            vddd-supply = <&foo>;
            vdda-supply = <&bar>;
        };
    };
  - |
    # include <dt-bindings/gpio/gpio.h>
    # include <dt-bindings/interrupt-controller/irq.h>
    spi {
        #address-cells = <1>;
        #size-cells = <0>;
        pressure@0 {
            compatible = "bosch,bmp280";
            reg = <0>;
            spi-max-frequency = <10000000>;
            reset-gpios = <&gpio0 26 GPIO_ACTIVE_LOW>;
            vddd-supply = <&foo>;
            vdda-supply = <&bar>;
        };
    };
